package cn.estsh.i3plus.core.api.iservice.base;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.platform.platbean.SysLogException;
import cn.estsh.i3plus.pojo.platform.platbean.SysLogOperate;
import cn.estsh.i3plus.pojo.platform.platbean.SysLogSystem;
import cn.estsh.i3plus.pojo.platform.platbean.SysLogTaskTime;
import io.swagger.annotations.ApiOperation;

import java.util.List;
import java.util.Map;

/**
 * @Description :
 * @Reference :
 * @Author : wei.peng
 * @CreateDate : 20-2-13 下午3:43
 * @Modify:
 **/
public interface ISysLogService {

    /********************************************************* 系统异常日志 Start *********************************************************/

    @ApiOperation(value = "系统异常日志复杂查询，分页，排序")
    ListPager<SysLogException> querySysLogExceptionByPager(SysLogException sysLogException, Pager pager);

    @ApiOperation(value = "删除指定日期之后的日志")
    long deleteSysLogExceptionByDateTimeAfter(String dateTime);

    /******************************************************* 系统异常日志 End *********************************************************/


    /********************************************************* 操作日志 Start *********************************************************/

    @ApiOperation(value = "添加操作日志",notes = "添加操作日志")
    SysLogOperate insertSysLogOperate(SysLogOperate logOperate);

    @ApiOperation(value = "根据id删除日志",notes = "根据id删除日志")
    void deleteSysLogOperateById(Long id);

    @ApiOperation(value = "查询全部操作日志",notes = "查询全部操作日志")
    List listSysLogOperate();

    @ApiOperation(value = "批量删除日志",notes = "批量删除日志")
    void deleteSysLogOperateByIds(Long[] ids);

    @ApiOperation(value = "根据id查询操作日志",notes = "根据id查询操作日志")
    SysLogOperate getSysLogOperateById(Long id);

    @ApiOperation(value = "根据操作人姓名模糊查询日志",notes = "根据操作人姓名模糊查询日志")
    List<SysLogOperate> listSysLogOperateByOperateUserName(String operateUserName);

    @ApiOperation(value = "查询所有日志数量")
    long countAllSysLogOperate();

    @ApiOperation(value = "操作日志复杂查询，分页，排序",notes = "操作日志复杂查询，分页，排序")
    ListPager<SysLogOperate> querySysLogOperateByPager(SysLogOperate logOperate, Pager pager);

    @ApiOperation(value = "查询最新的操作日志")
    List<SysLogOperate> findNewSysLogOperate(Integer num);

    @ApiOperation(value = "删除指定日期之后的日志")
    long deleteSysLogOperateByDateTimeAfter(String dateTime);

    @ApiOperation(value = "操作日志数量")
    long countSysLogOperate();

    /******************************************************* 操作日志 End *********************************************************/


    /******************************************************* 系统日志 Start *********************************************************/

    @ApiOperation(value = "添加系统日志",notes = "添加系统日志")
    void insertSysLogSystem(SysLogSystem logSystem);

    @ApiOperation(value = "造数据系统日志",notes = "造数据")
    void insertSysLogBatch(int num,int waitTime);

    @ApiOperation(value = "删除日志",notes = "删除日志")
    long deleteSysLogSystemById(Long id);

    @ApiOperation(value = "查询全部日志",notes = "查询全部日志")
    List<SysLogSystem> listSysLogSystem();

    @ApiOperation(value = "根据id查询系统日志",notes = "根据id查询系统日志")
    SysLogSystem getSysLogSystemById(long id);

    @ApiOperation(value = "系统日志分页复杂查询",notes = "系统日志分页复杂查询")
    ListPager querySysLogSystemByPager(SysLogSystem logSystem, Pager pager);

    @ApiOperation(value = "系统日志批量删除",notes = "系统日志批量删除")
    long deleteSysLogSystemByIds(Long[] ids);

    @ApiOperation(value = "系统日志按id区间查询",notes = "系统日志按id区间查询")
    List<SysLogSystem> findSysLogSystemByIdInterval(long min, long max);

    @ApiOperation(value = "删除指定日期之后的日志",notes = "系统日志按id区间查询")
    long deleteSysLogSystemByDateTimeAfter(String dateTime);

    /******************************************************* 系统日志 End *********************************************************/


    /******************************************************* 定时任务日志 Start *********************************************************/
    @ApiOperation(value = "添加定时任务日志",notes = "添加定时任务日志")
    void insertSysLogTaskTime(SysLogTaskTime sysLogTaskTime);

    @ApiOperation(value = "删除定时任务日志",notes = "删除定时任务日志")
    void deleteSysLogTaskTimeById(Long id);

    @ApiOperation(value = "根据id查询定时任务日志",notes = "根据id查询定时任务日志")
    SysLogTaskTime getSysLogTaskTimeById(Long id);

    @ApiOperation(value = "定时任务日志分页复杂查询",notes = "定时任务日志分页复杂查询")
    ListPager querySysLogTaskTimeByPager(SysLogTaskTime sysLogTaskTime, Pager pager);

    @ApiOperation(value = "删除指定日期之后的日志",notes = "删除指定日期之后的日志")
    long deleteSysLogTaskTimeByDateTimeAfter(String dateTime);

    /******************************************************* 定时任务日志 End *********************************************************/


    /********************************************************* 操作日志 Start *********************************************************/

    @ApiOperation(value = "查询时间段内平均请求耗时",notes = "查询时间段内平均请求耗时")
    Map<String, Object> querySysLogSystemAvgExecuteTime(String startTime, String endTime);

    @ApiOperation(value = "查询时间段内各等级日志数量",notes = "查询时间段内各等级日志数量")
    Map<String, Object> querySysLogSystemByLevel(String startTime, String endTime);

    /******************************************************* 系统异常日志 End *********************************************************/

}
