package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.platform.bean.SysFileAttach;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Description : 文件附件接口
 * @Reference :
 * @Author : yunhao
 * @Date : 2018-10-25 17:10
 * @Modify :
 **/
public interface ISysFileAttachService {

    /**
     * 添加附件信息
     * @param sysFileAttach 附件信息
     * @return 添加后的附件信息
     */
    @ApiOperation(value = "添加附件信息")
    SysFileAttach insertSysFileAttach(SysFileAttach sysFileAttach);

    /**
     * 根据id删除附件信息
     * @param id 附件信息id
     */
    @ApiOperation(value = "根据id删除附件信息")
    void deleteSysFileAttachById(Long id);

    /**
     * 根据RefId查询
     * @param refId 关系id
     */
    @ApiOperation(value = "根据id删除附件信息")
    List<SysFileAttach> findSysFileAttachByRefId(Long refId);

    /**
     * 根据RefId删除
     * @param refId 关系id
     */
    @ApiOperation(value = "根据id删除附件信息")
    void deleteSysFileAttachByRefId(Long refId);

}
