package cn.estsh.i3plus.core.apiservice.configuration;

import cn.estsh.i3plus.platform.common.util.CommonConstWords;
import cn.estsh.i3plus.pojo.base.jpa.factory.BaseMongoRepositoryFactoryBean;
import cn.estsh.i3plus.pojo.base.jpa.factory.BaseRepositoryFactoryBean;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.autoconfigure.condition.ConditionalOnExpression;
import org.springframework.boot.autoconfigure.domain.EntityScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;
import org.springframework.data.mongodb.repository.config.EnableMongoRepositories;

/**
 * @Description : 需要扫描其他包的配置文件
 *                  此类专门添加需要单独加载的其他模块的包
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-12-12 20:49
 * @Modify:
 **/
@Configuration
@ConditionalOnExpression("'${" + CommonConstWords.PROP_SWITCH_MONGO + ":false}' == 'true'")
//扫描需要单独处理的持久化包
@EnableMongoRepositories(basePackages = {
        "cn.estsh.i3plus.**.platrepositorymongo"
},repositoryFactoryBeanClass = BaseMongoRepositoryFactoryBean.class)
public class ScanMongoPackageConfiguration {
    public static final Logger LOGGER = LoggerFactory.getLogger(CommonConstWords.SYSTEM_LOG);

    public ScanMongoPackageConfiguration(){
        LOGGER.info("【扫描关联包...】");
    }
}
