//package cn.estsh.i3plus.core.apiservice.controller;
//
//import cn.estsh.i3plus.core.api.iservice.busi.ITestService;
//import cn.estsh.i3plus.core.api.iservice.busi.ITestTransService;
//import cn.estsh.i3plus.pojo.platform.bean.TestTransUser;
//import cn.estsh.impp.framework.base.controller.CoreBaseController;
//import cn.estsh.impp.framework.boot.util.ResultBean;
//import io.swagger.annotations.Api;
//import io.swagger.annotations.ApiOperation;
//import org.slf4j.Logger;
//import org.slf4j.LoggerFactory;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.web.bind.annotation.PostMapping;
//import org.springframework.web.bind.annotation.RequestMapping;
//import org.springframework.web.bind.annotation.RequestParam;
//import org.springframework.web.bind.annotation.RestController;
//
//import java.util.List;
//
///**
// * @Description : 对事务以及entityManager的操作演示
// * @Reference :
// * @Author : alwaysfrin
// * @CreateDate : 2019-04-29 17:20
// * @Modify:
// **/
//@RestController
//@Api(tags = "对事务以及entityManager的操作演示")
//@RequestMapping("/demo-trans")
//public class DemoTransactionController extends CoreBaseController {
//    private static final Logger LOGGER = LoggerFactory.getLogger(DemoTransactionController.class);
//
//    @Autowired
//    private ITestTransService transService;
//
//    @Autowired
//    private ITestService testService;
//
//
//    /**
//     * 属性更新
//     * @return 处理结果
//     */
//    @PostMapping("/trans-test-redis")
//    @ApiOperation(value = "事务测试缓存")
//    public ResultBean testRedisTrans(String name,String val) {
//        transService.testRedisTrans(name,val);
//
//        return ResultBean.success("事务测试缓存");
//    }
//
//    /**
//     * dao混合调用
//     *
//     * @param type 调用参数
//     * @param name 名称
//     * @return 处理结果
//     */
//    @PostMapping("/test1")
//    @ApiOperation(value = "dao混合调用")
//    public ResultBean transTest1(int type, String name) {
//        transService.testListTran(type, name);
//
//        return ResultBean.success("测试成功");
//    }
//
//    /**
//     * 测试多数据源切换
//     *
//     * @return 处理结果
//     */
//    @PostMapping("/test-dynamic-datasource")
//    @ApiOperation(value = "测试多数据源切换")
//    public ResultBean testDynamicDataSource(int type) {
//        //多服务调用
//        startMultiService();
//
//        if(type == 1){
//            System.out.println("====先查后插入====");
//            List<TestTransUser> uList = transService.listRead();
//            System.out.println("对象总数：" + uList.size());
//
//            System.out.println("开始插入");
//            transService.write();
//
//            uList = transService.listRead();
//            System.out.println("再次查询：" + uList.size());
//        }else if(type == 2){
//            System.out.println("====先插入后查====");
//            System.out.println("开始插入");
//            transService.write();
//
//            List<TestTransUser> uList = transService.listRead();
//            System.out.println("对象总数：" + uList.size());
//
//            if(uList.size() > 0){
//                throw new RuntimeException("111");
//            }
//        }else if(type == 3){
//            System.out.println("====先查后插入====");
//            List<TestTransUser> uList = transService.listRead();
//            System.out.println("对象总数：" + uList.size());
//
//            System.out.println("开始插入");
//            testService.write();
//
//            uList = transService.listRead();
//            System.out.println("再次查询：" + uList.size());
//        }
//
//        return ResultBean.success("测试成功");
//    }
//
//
//    /**
//     * 测试多数据源切换（Controller调用）
//     *
//     * @return 处理结果
//     */
//    @PostMapping("/test-dynamic-datasource-more")
//    @ApiOperation(value = "测试多数据源切换")
//    public ResultBean testDynamicDataSourceWithController(boolean withMulti) {
//        if(withMulti) {
//            //多服务调用
//            startMultiService();
//        }
//
//        //读
//        readWriteTransactionTest(1);
//        //写
//        readWriteTransactionTest(2);
//
//        return ResultBean.success("测试成功");
//    }
//
//    /**
//     * 读写分离-事务测试
//     * @return 处理结果
//     */
//    @PostMapping("/read-write-test")
//    @ApiOperation(value = "读写分离-事务测试")
//    public ResultBean readWriteTransactionTest(@RequestParam("testType") int testType) {
//        if(testType == 1) {
//            //读
//            List<TestTransUser> uList = transService.listRead();
//            System.out.println("对象总数：" + uList.size());
//            for (TestTransUser u : uList){
//                System.out.println(u);
//            }
//        }else if(testType == 2) {
//            //写
//            transService.write();
//        }else if(testType == 3) {
//            //读写（写事务）
//            transService.transReadWrite();
//        }else if(testType == 4) {
//            //读写（写事务）
//            transService.readWrite();
//        }
//
//        return ResultBean.success("测试成功");
//    }
//
//    /******************* 事务并发出现的问题*******************/
//
//    /**
//     * 第一类丢失更新
//     * @param name 更新的name的值
//     * @param time 停止时间，秒
//     * @param execp 是否抛出异常
//     * @return 处理结果
//     */
//    @PostMapping("/update-lost")
//    @ApiOperation(value = "第一类丢失更新")
//    public ResultBean updateLost1(String name,int time,boolean execp) {
//        transService.updateLost(name,time,execp);
//
//        return ResultBean.success("幻读模拟结束");
//    }
//
//    /**
//     * 第二类丢失更新
//     * @return 处理结果
//     */
//    @PostMapping("/update-lost-trans")
//    @ApiOperation(value = "第二类丢失更新")
//    public ResultBean updateLostTrans(String name,double salary,int time,boolean execp) {
//        transService.updateLostTrans(name,salary,time,execp);
//
//        return ResultBean.success("第二类丢失更新结束");
//    }
//
//    /**
//     * 模拟脏读
//     * @return 处理结果
//     */
//    @PostMapping("/trans-dirty-a")
//    @ApiOperation(value = "脏读模拟A")
//    public ResultBean transDirtyA(long id) {
//        try{
//            transService.writeDirtyA(id);
//        }catch(Exception e){
//            System.out.println(e.getMessage());
//        }
//
//        return ResultBean.success("脏读模拟A结束");
//    }
//
//    /**
//     * 模拟脏读
//     * @return 处理结果
//     */
//    @PostMapping("/trans-dirty-b")
//    @ApiOperation(value = "脏读模拟B")
//    public ResultBean transDirtyB(long id) {
//        transService.writeDirtyB(id);
//
//        return ResultBean.success("脏读模拟B结束");
//    }
//
//    /**
//     * 模拟不可重复读A
//     * @return 处理结果
//     */
//    @PostMapping("/trans-repeat-a")
//    @ApiOperation(value = "不可重复读A")
//    public ResultBean transRepeatA(long id) {
//        transService.writeRepeatA(id);
//
//        return ResultBean.success("不可重复读A结束");
//    }
//
//    /**
//     * 模拟不可重复读B
//     * @return 处理结果
//     */
//    @PostMapping("/trans-repeat-b")
//    @ApiOperation(value = "不可重复读B")
//    public ResultBean transRepeatB(long id) {
//        transService.writeRepeatB(id);
//
//        return ResultBean.success("不可重复读B结束");
//    }
//
//    /**
//     * 模拟幻读
//     * @return 处理结果
//     */
//    @PostMapping("/trans-phantom-a")
//    @ApiOperation(value = "幻读模拟A")
//    public ResultBean transPhantomA(long id,boolean listOrDelete) {
//        try {
//            transService.writePhantomA(id, listOrDelete);
//        }catch(Exception e){
//            System.out.println("幻读异常：" + e.getMessage());
//        }
//
//        return ResultBean.success("幻读模拟A结束");
//    }
//
//    /**
//     * 模拟幻读
//     * @return 处理结果
//     */
//    @PostMapping("/trans-phantom-b")
//    @ApiOperation(value = "幻读模拟B")
//    public ResultBean transPhantomB() {
//        transService.writePhantomB();
//
//        return ResultBean.success("幻读模拟B结束");
//    }
//
//    /********************* 事务传播 *******************/
//
//    /**
//     * 事务传播-创建新事物
//     * @return 处理结果
//     */
//    @PostMapping("/trans-require-new")
//    @ApiOperation(value = "创建新事务")
//    public ResultBean transRequireNew() {
//        transService.writeRequireNew();
//
//        return ResultBean.success("require-new结束");
//    }
//
//    /**
//     * 事务传播-mandatory
//     * @return 处理结果
//     */
//    @PostMapping("/trans-mandatory")
//    @ApiOperation(value = "没有事务抛出异常")
//    public ResultBean transMandatory() {
//        transService.writeTransMandatory();
//
//        return ResultBean.success("mandatory结束");
//    }
//
//    /******************* 事务隔离级别 *******************/
//    //调用事务出现的问题，打开事务注释
//
//    /********************* 乐观锁 Optimistic lock *******************/
//
//    /**
//     * 乐观锁A
//     * @return 处理结果
//     */
//    @PostMapping("/trans-optimistic-a")
//    @ApiOperation(value = "乐观锁 Optimistic lockA")
//    public ResultBean transOptimisticA(long id,int type) {
//        transService.writeOptimisticA(id,type);
//
//        return ResultBean.success("乐观锁 Optimistic lockA结束");
//    }
//
//    /**
//     * 乐观锁B
//     * @return 处理结果
//     */
//    @PostMapping("/trans-optimistic-b")
//    @ApiOperation(value = "乐观锁 Optimistic lockB")
//    public ResultBean transOptimisticB(long id,int type) {
//        transService.writeOptimisticB(id,type);
//
//        return ResultBean.success("乐观锁 Optimistic lockB结束");
//    }
//
//    /********************* 悲观锁 Pessimistic Lock *******************/
//    /**
//     * 悲观锁A
//     * @return 处理结果
//     */
//    @PostMapping("/trans-pessimistic-a")
//    @ApiOperation(value = "悲观锁 pessimistic lockA")
//    public ResultBean transPessimisticA(long id,int type) {
//        transService.writePessimisticA(id,type);
//
//        return ResultBean.success("悲观锁 pessimistic lockA结束");
//    }
//
//    /**
//     * 悲观锁B
//     * @return 处理结果
//     */
//    @PostMapping("/trans-pessimistic-b")
//    @ApiOperation(value = "悲观锁 pessimistic lockB")
//    public ResultBean transPessimisticB(long id,int type) {
//        transService.writePessimisticB(id,type);
//
//        return ResultBean.success("悲观锁 pessimistic lockB结束");
//    }
//
//    /********************* 事务设计 *******************/
//
//    /**
//     * 通常（可能出现问题）
//     * @return 处理结果
//     */
//    @PostMapping("/trans-pattern-wrong")
//    @ApiOperation(value = "常见事务处理（可能出现并发问题）")
//    public ResultBean transPatternWrong(long id,double salary) {
//        transService.writePatternWrong(id,salary);
//
//        return ResultBean.success("常见事务处理");
//    }
//
//    /**
//     * 线程锁（性能）
//     * @return 处理结果
//     */
//    @PostMapping("/trans-pattern-synchronized")
//    @ApiOperation(value = "事务模式-线程锁")
//    public ResultBean transPatternSynchron(long id,double salary) {
//        transService.writePatternSynchron(id,salary);
//
//        return ResultBean.success("事务模式-线程锁");
//    }
//
//    /**
//     * 乐观锁
//     * @return 处理结果
//     */
//    @PostMapping("/trans-pattern-opti")
//    @ApiOperation(value = "事务模式-乐观锁")
//    public ResultBean transPatternOpti(long id,double salary) {
//        transService.writePatternOpti(id,salary);
//
//        return ResultBean.success("事务模式-乐观锁");
//    }
//
//    /**
//     * 悲观锁
//     * @return 处理结果
//     */
//    @PostMapping("/trans-pattern-pessi")
//    @ApiOperation(value = "事务模式-悲观锁")
//    public ResultBean transPatternPessi(long id,double salary) {
//        transService.writePatternPessi(id,salary);
//
//        return ResultBean.success("事务模式-悲观锁");
//    }
//
//    /**
//     * 属性更新
//     * @return 处理结果
//     */
//    @PostMapping("/trans-pattern-param-update")
//    @ApiOperation(value = "事务模式-属性更新")
//    public ResultBean transPatternParamUpdate(long id,double salary) {
//        transService.writePatternParamUpdate(id,salary);
//
//        return ResultBean.success("事务模式-属性更新");
//    }
//}
