package cn.estsh.i3plus.core.apiservice.daoimpl;

import cn.estsh.i3plus.core.apiservice.dao.ITestTransDao;
import cn.estsh.i3plus.pojo.platform.bean.SysTool;
import cn.estsh.i3plus.pojo.platform.bean.SysUser;
import cn.estsh.i3plus.pojo.platform.bean.SysUserInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import javax.persistence.metamodel.EntityType;
import javax.persistence.metamodel.ManagedType;
import javax.persistence.metamodel.Metamodel;
import java.util.List;

/**
 * @Description :
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2019-04-29 17:31
 * @Modify:
 **/
@Service
public class TestTransDaoImpl implements ITestTransDao {

    @Autowired
    private EntityManager entityManager;

    @Override
    public List listUser(String name) {
        System.out.println("======listUser=====");
        Metamodel mm = entityManager.getMetamodel();
        for(EntityType<?> s : mm.getEntities()){
            System.out.println("entityType : " + s.getName());
        }
        for(ManagedType<?> s : mm.getEntities()){
            System.out.println("ManagedType : " + s.getPersistenceType().name());
        }

        System.out.println(entityManager.getDelegate() + "====" + entityManager);
        System.out.println("======listUser end=====");

        String hql = "select m from SysUserInfo m where m.name = :name";
        Query query = entityManager.createQuery(hql,SysUserInfo.class);
        query.setParameter("name", name);

        return query.getResultList();
    }

    @Override
    public SysUserInfo getUser(String name) {
        System.out.println("======getUser=====");
        Metamodel mm = entityManager.getMetamodel();
        for(EntityType<?> s : mm.getEntities()){
            System.out.println("entityType : " + s.getName());
        }
        for(ManagedType<?> s : mm.getEntities()){
            System.out.println("ManagedType : " + s.getPersistenceType().name());
        }

        System.out.println(entityManager.getDelegate() + "====" + entityManager);
        System.out.println("======getUser end=====");

        String hql = "select m from SysUserInfo m where m.name = :name";
        Query query = entityManager.createQuery(hql,SysUserInfo.class);
        query.setParameter("name", name);

        return (SysUserInfo) query.getSingleResult();
    }

    @Override
    public List listSysTool(String name) {
        System.out.println("======listSysTool=====");
        Metamodel mm = entityManager.getMetamodel();
        for(EntityType<?> s : mm.getEntities()){
            System.out.println("entityType : " + s.getName());
        }
        for(ManagedType<?> s : mm.getEntities()){
            System.out.println("ManagedType : " + s.getPersistenceType().name());
        }

        System.out.println(entityManager.getDelegate() + "====" + entityManager);
        System.out.println("======listSysTool end=====");

        String hql = "select m from SysTool m where m.name = :name";
        Query query = entityManager.createQuery(hql,SysTool.class);
        query.setParameter("name", name);

        return query.getResultList();
    }

    @Override
    public SysTool getSysTool(String name) {
        System.out.println("======getSysTool=====");
        Metamodel mm = entityManager.getMetamodel();
        for(EntityType<?> s : mm.getEntities()){
            System.out.println("entityType : " + s.getName());
        }
        for(ManagedType<?> s : mm.getEntities()){
            System.out.println("ManagedType : " + s.getPersistenceType().name());
        }

        System.out.println(entityManager.getDelegate() + "====" + entityManager);
        System.out.println("======getSysTool end=====");

        String hql = "select m from SysTool m where m.name = :name";
        Query query = entityManager.createQuery(hql,SysTool.class);
        query.setParameter("name", name);

        return (SysTool) query.getSingleResult();
    }
}
