package cn.estsh.i3plus.core.apiservice.mq;

import cn.estsh.i3plus.platform.common.util.PlatformConstWords;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.amqp.core.Queue;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import static cn.estsh.i3plus.platform.common.util.PlatformConstWords.QUEUE_IMPP_MESSAGE;

/**
 * @Description : wms队列
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-09-26 16:57
 * @Modify:
 **/
@Configuration
public class I3CoreQueueConfig {
    private static final Logger LOGGER = LoggerFactory.getLogger(I3CoreQueueConfig.class);

    /**
     * 开启平台消息队列
     * @return 队列
     */
    @Bean
    public Queue getImppMessageQueue() {
        LOGGER.info("【开启平台消息队列】");
        return new Queue(QUEUE_IMPP_MESSAGE);
    }

    /**
     * QUEUE_IMPP_MESSAGE_LETTER 队列
     * @return 队列
     * @throws Exception
     */
    @Bean
    public Queue getQueueImppMessageLetterQueue(){
        return new Queue(PlatformConstWords.QUEUE_IMPP_MESSAGE_LETTER);
    }

    /**
     * QUEUE_IMPP_MESSAGE_MAIL 队列
     * @return 队列
     * @throws Exception
     */
    @Bean
    public Queue getQueueImppMessageMailQueue(){
        return new Queue(PlatformConstWords.QUEUE_IMPP_MESSAGE_MAIL);
    }

    /**
     * QUEUE_SWEB_NOTICE 队列
     * @return 队列
     * @throws Exception
     */
    @Bean
    public Queue getQueueSwebNoticeQueue(){
        return new Queue(PlatformConstWords.QUEUE_SWEB_NOTICE);
    }

    /**
     * QUEUE_IMPP_SCHEDULE
     * @return 队列
     * @throws Exception
     */
    @Bean
    public Queue getQueueImppScheduleQueue(){
        return new Queue(PlatformConstWords.QUEUE_IMPP_SCHEDULE);
    }

    /**
     * 资源国际化队列
     * @return
     */
    @Bean
    public Queue getQueueImppResource(){
        return new Queue(PlatformConstWords.QUEUE_IMPP_RESOURCE);
    }

}
